package handler

import (
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/brand_store"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/kitchen"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/order"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/product"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/public"
	"github.com/cloudwego/kitex/server"
	"github.com/google/wire"
)

var ProviderSet = wire.NewSet(Register, kitchen.NewKitchenService, brand_store.NewBrandService, public.NewPublicService, product.NewProductService, order.NewOrderService)

func Register(kitchenService *kitchen.KitchenService, brandService *brand_store.BrandService, publicService *public.PublicService, productService *product.Service, orderService *order.OrderService) []func(svr server.Server) error {
	var services []func(svr server.Server) error
	services = append(services, kitchen.RegistryKitchen(kitchenService))
	services = append(services, brand_store.RegistryBrand(brandService))
	services = append(services, public.RegistryPublic(publicService))
	services = append(services, product.RegistryProduct(productService))
	services = append(services, order.RegistryOrder(orderService))
	return services
}
