package kitchen

import (
	"context"
	"git.downtown8.com/rms/g-common/g-common/constants/errorcode"
	"git.downtown8.com/rms/g-kitchen/hera/kitex_gen/kitchenworkstation"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/rpcclient"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/kitex_gen/hqKitchenCenter/hqkitchenservice"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/kitex_gen/hqKitchenWorkstation"
	"github.com/cloudwego/kitex/server"
	"github.com/jinzhu/copier"
)

type KitchenService struct {
	rpcClient *rpcclient.Client
}

func NewKitchenService(client *rpcclient.Client) *KitchenService {
	o := &KitchenService{
		rpcClient: client,
	}
	return o
}

func RegistryKitchen(svc *KitchenService) func(svr server.Server) error {
	return func(svr server.Server) error {
		return hqkitchenservice.RegisterService(svr, svc)
	}
}

func (k *KitchenService) CreateKitchen(ctx context.Context, req *hqKitchenWorkstation.CreateKitchenRequest) (res *hqKitchenWorkstation.CreateResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) UpdateKitchen(ctx context.Context, req *hqKitchenWorkstation.UpdateKitchenRequest) (res *hqKitchenWorkstation.UpdateKitchenResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) DeleteKitchen(ctx context.Context, req *hqKitchenWorkstation.DeleteKitchenRequest) (res *hqKitchenWorkstation.DeleteKitchenResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) DetailKitchen(ctx context.Context, req *hqKitchenWorkstation.DetailKitchenRequest) (res *hqKitchenWorkstation.DetailResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) ListKitchen(ctx context.Context, req *hqKitchenWorkstation.ListKitchenRequest) (res *hqKitchenWorkstation.ListResponse, err error) {
	kitchenWorkstationResp, err := k.rpcClient.KitchenCenter.List(ctx, &kitchenworkstation.ListRequest{
		StoreId:  req.GetStoreId(),
		BrandId:  req.GetBrandId(),
		Page:     req.GetPage(),
		PageSize: req.GetPageSize(),
	})
	if err != nil {
		return &hqKitchenWorkstation.ListResponse{
			Code: errorcode.ERR_CODE_NOT_SET,
			Msg:  err.Error(),
		}, nil
	}
	return &hqKitchenWorkstation.ListResponse{
		Code: kitchenWorkstationResp.GetCode(),
		Msg:  kitchenWorkstationResp.GetMsg(),
	}, nil
}

func (k *KitchenService) ListKitchenBySu(ctx context.Context, req *hqKitchenWorkstation.ListKitchenBySuRequest) (res *hqKitchenWorkstation.ListKitchenBySuResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) ImportSu(ctx context.Context, req *hqKitchenWorkstation.ImportSuRequest) (res *hqKitchenWorkstation.ImportSuResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) SetTakeout(ctx context.Context, req *hqKitchenWorkstation.SetTakeoutRequest) (res *hqKitchenWorkstation.SetTakeoutResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) DetailKitchenReceiptPrinterRule(ctx context.Context, req *hqKitchenWorkstation.DetailKitchenReceiptPrinterRuleRequest) (res *hqKitchenWorkstation.DetailKitchenReceiptPrinterRuleRsp, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) DeleteKitchenReceiptPrinterRule(ctx context.Context, req *hqKitchenWorkstation.DeleteKitchenReceiptPrinterRuleRequest) (res *hqKitchenWorkstation.DeleteKitchenReceiptPrinterRuleResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) UpdateKitchenReceiptPrinterRule(ctx context.Context, req *hqKitchenWorkstation.UpdateKitchenReceiptPrinterRuleRequest) (res *hqKitchenWorkstation.UpdateKitchenReceiptPrinterRuleResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) CreateKitchenReceiptPrinterRule(ctx context.Context, req *hqKitchenWorkstation.CreateKitchenReceiptPrinterRuleRequest) (res *hqKitchenWorkstation.CreateKitchenReceiptPrinterRuleResponse, err error) {
	//TODO implement me
	panic("implement me")
}

func (k *KitchenService) CountKitchenReceiptPrinterRule(ctx context.Context, req *hqKitchenWorkstation.CountKitchenReceiptPrinterRuleRequest) (res *hqKitchenWorkstation.CountKitchenReceiptPrinterRuleResponse, err error) {
	r, err := k.rpcClient.KitchenCenter.CountKitchenReceiptPrinterRule(ctx, &kitchenworkstation.CountKitchenReceiptPrinterRuleRequest{
		StoreId: req.GetStoreId(),
		BrandId: req.GetBrandId(),
	})
	if err != nil {
		return &hqKitchenWorkstation.CountKitchenReceiptPrinterRuleResponse{
			Code: errorcode.ERR_CODE_NOT_SET,
			Msg:  err.Error(),
		}, nil
	}
	data := make([]*hqKitchenWorkstation.CountKitchenReceiptPrinterRuleResponseData, 0)
	copier.Copy(&data, r.GetData())
	return &hqKitchenWorkstation.CountKitchenReceiptPrinterRuleResponse{
		Code: r.GetCode(),
		Msg:  r.GetMsg(),
		Data: data,
	}, nil
}
