package order

import (
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/message/rabbitmq"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/rpcclient"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/kitex_gen/hqOrderCenter/hqorderservice"
	"github.com/cloudwego/kitex/server"
)

type OrderService struct {
	rpcClient *rpcclient.Client
	mq        *rabbitmq.Client
}

func NewOrderService(client *rpcclient.Client, rc *rabbitmq.Client) *OrderService {
	o := &OrderService{
		rpcClient: client,
		mq:        rc,
	}
	return o
}

func RegistryOrder(svc *OrderService) func(svr server.Server) error {
	return func(svr server.Server) error {
		return hqorderservice.RegisterService(svr, svc)
	}
}
