package novu

import "context"

// 公共

const (
	PosOrderTutorialWorkflow  = "pos-order-tutorial-workflow"
	PrinterConnectionWorkflow = "printer-connection-tutorial-workflow"
)

type PosOrderTutorialWorkflowPayload struct {
	BizType         string `json:"bizType"`
	ShowBanner      bool   `json:"showBanner"`
	EmployeeName    string `json:"employeeName"`
	PosDinePayModel string `json:"posDinePayModel"`
}

// PublishPosOrderTutorialWorkflow pos下单新手引导教学
func (m *Client) PublishPosOrderTutorialWorkflow(ctx context.Context, storeId int32, traceId string, payload *PosOrderTutorialWorkflowPayload) error {
	return m.publishNovu(ctx, PosOrderTutorialWorkflow, storeId, traceId, payload)
}

type PrintFailureWorkflowPayload struct {
	BizType      string `json:"bizType"`
	ShowBanner   bool   `json:"showBanner"`
	EmployeeName string `json:"employeeName"`
}

// PublishPrinterConnectionTutorialWorkflow pos链接打印机新手引导教学
func (m *Client) PublishPrinterConnectionTutorialWorkflow(ctx context.Context, storeId int32, traceId string, payload *PrintFailureWorkflowPayload) error {
	return m.publishNovu(ctx, PrinterConnectionWorkflow, storeId, traceId, payload)
}
