package producer

import (
	"context"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/svc/amqp"
)

type RabbitMQProducer struct {
	mq *amqp.RabbitMQ
}

func New(mq *amqp.RabbitMQ) *RabbitMQProducer {
	return &RabbitMQProducer{
		mq: mq,
	}
}

func (m *RabbitMQProducer) publishMq(ctx context.Context, data []byte, exchange string, routingKey string) {
	m.mq.PublishMsg(ctx, amqp.Msg{
		Exchange:   exchange,
		RoutingKey: routingKey,
		Data:       data,
	})
}
