package kitchen

import (
	"context"
	"fmt"
	"git.downtown8.com/rms/g-kitchen/hera/kitex_gen/kitchencenter/kitchencenterservice"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/config"
	"github.com/cloudwego/kitex/client"
	"github.com/cloudwego/kitex/pkg/endpoint"
	_ "github.com/cloudwego/kitex/pkg/remote/codec/protobuf/encoding/gzip"
	"github.com/cloudwego/kitex/pkg/remote/trans/nphttp2/metadata"
	"github.com/cloudwego/kitex/pkg/rpcinfo"
	"github.com/cloudwego/kitex/transport"
)

type Center struct {
	rpcCall kitchencenterservice.Client
}

func New(c config.Config) *Center {
	rpcCall := kitchencenterservice.MustNewClient(c.KitchenCenterSvc.Name, client.WithTransportProtocol(transport.GRPC),
		client.WithHostPorts(fmt.Sprintf("%s:%d", c.KitchenCenterSvc.Addr, c.KitchenCenterSvc.Port)),
		client.WithClientBasicInfo(&rpcinfo.EndpointBasicInfo{ServiceName: c.Application.Name}),
		client.WithMiddleware(func(next endpoint.Endpoint) endpoint.Endpoint {
			return func(ctx context.Context, req, resp interface{}) (err error) {
				md, ok := metadata.FromIncomingContext(ctx)
				if ok {
					ctx = metadata.NewOutgoingContext(ctx, md)
				}
				return next(ctx, req, resp)
			}
		}),
	)
	return &Center{rpcCall: rpcCall}
}
