package product

import (
	"context"
	"errors"
	"git.downtown8.com/golang/common/onelog"
	"git.downtown8.com/rms/g-product/hera/kitex_gen/saleunit"
	_ "github.com/cloudwego/kitex/pkg/remote/codec/protobuf/encoding/gzip"
	"github.com/sirupsen/logrus"
)

func (c *Center) ImportSuStandard(ctx context.Context, req *saleunit.ImportSuStandardReq) (*saleunit.ImportSuStandardRes, error) {
	r, err := c.rpcCall.ImportSuStandard(ctx, req)
	if err != nil {
		onelog.CtxErrorOptions(ctx, "rpc call ImportSuStandard error", logrus.Fields{
			"err": err,
			"req": req,
		})
		return nil, errors.New("server error")
	}

	if r.GetCode() != 0 {
		onelog.CtxErrorOptions(ctx, "rpc call ImportSuStandard error", logrus.Fields{
			"err":  err,
			"req":  req,
			"code": r.GetCode(),
			"msg":  r.GetMsg(),
		})
	}
	return r, nil
}
