package public

import (
	"context"
	"errors"
	"git.downtown8.com/golang/common/onelog"
	"git.downtown8.com/rms/public/hera/kitex_gen/todo"
	_ "github.com/cloudwego/kitex/pkg/remote/codec/protobuf/encoding/gzip"
	"github.com/sirupsen/logrus"
)

func (c *Center) TodoDefaultCreate(ctx context.Context, req *todo.TodoDefaultCreateReq) (*todo.TodoFinishedRsp, error) {
	r, err := c.rpcCall.TodoDefaultCreate(ctx, req)
	if err != nil {
		onelog.CtxErrorOptions(ctx, "rpc call TodoDefaultCreate error", logrus.Fields{
			"err": err,
			"req": req,
		})
		return nil, errors.New("server error")
	}

	if r.GetCode() != 0 {
		onelog.CtxErrorOptions(ctx, "rpc call TodoDefaultCreate error", logrus.Fields{
			"err":  err,
			"req":  req,
			"code": r.GetCode(),
			"msg":  r.GetMsg(),
		})
	}
	return r, nil
}
