// Code generated by Kitex v0.11.0. DO NOT EDIT.

package hqorderservice

import (
	"context"
	"errors"
	hqOrderCenter "git.downtown8.com/rms/orchestrator/g-hq-orchestrator/kitex_gen/hqOrderCenter"
	hqOrderReceipt "git.downtown8.com/rms/orchestrator/g-hq-orchestrator/kitex_gen/hqOrderReceipt"
	client "github.com/cloudwego/kitex/client"
	kitex "github.com/cloudwego/kitex/pkg/serviceinfo"
	streaming "github.com/cloudwego/kitex/pkg/streaming"
	proto "google.golang.org/protobuf/proto"
)

var errInvalidMessageType = errors.New("invalid message type for service method handler")

var serviceMethods = map[string]kitex.MethodInfo{
	"CreateOrderReceipt": kitex.NewMethodInfo(
		createOrderReceiptHandler,
		newCreateOrderReceiptArgs,
		newCreateOrderReceiptResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"GetOrderReceiptList": kitex.NewMethodInfo(
		getOrderReceiptListHandler,
		newGetOrderReceiptListArgs,
		newGetOrderReceiptListResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"DelOrderReceipt": kitex.NewMethodInfo(
		delOrderReceiptHandler,
		newDelOrderReceiptArgs,
		newDelOrderReceiptResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"UpdateOrderReceipt": kitex.NewMethodInfo(
		updateOrderReceiptHandler,
		newUpdateOrderReceiptArgs,
		newUpdateOrderReceiptResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"CountOrderReceipt": kitex.NewMethodInfo(
		countOrderReceiptHandler,
		newCountOrderReceiptArgs,
		newCountOrderReceiptResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
}

var (
	hqOrderServiceServiceInfo                = NewServiceInfo()
	hqOrderServiceServiceInfoForClient       = NewServiceInfoForClient()
	hqOrderServiceServiceInfoForStreamClient = NewServiceInfoForStreamClient()
)

// for server
func serviceInfo() *kitex.ServiceInfo {
	return hqOrderServiceServiceInfo
}

// for stream client
func serviceInfoForStreamClient() *kitex.ServiceInfo {
	return hqOrderServiceServiceInfoForStreamClient
}

// for client
func serviceInfoForClient() *kitex.ServiceInfo {
	return hqOrderServiceServiceInfoForClient
}

// NewServiceInfo creates a new ServiceInfo containing all methods
func NewServiceInfo() *kitex.ServiceInfo {
	return newServiceInfo(false, true, true)
}

// NewServiceInfo creates a new ServiceInfo containing non-streaming methods
func NewServiceInfoForClient() *kitex.ServiceInfo {
	return newServiceInfo(false, false, true)
}
func NewServiceInfoForStreamClient() *kitex.ServiceInfo {
	return newServiceInfo(true, true, false)
}

func newServiceInfo(hasStreaming bool, keepStreamingMethods bool, keepNonStreamingMethods bool) *kitex.ServiceInfo {
	serviceName := "HqOrderService"
	handlerType := (*hqOrderCenter.HqOrderService)(nil)
	methods := map[string]kitex.MethodInfo{}
	for name, m := range serviceMethods {
		if m.IsStreaming() && !keepStreamingMethods {
			continue
		}
		if !m.IsStreaming() && !keepNonStreamingMethods {
			continue
		}
		methods[name] = m
	}
	extra := map[string]interface{}{
		"PackageName": "hqOrderCenter",
	}
	if hasStreaming {
		extra["streaming"] = hasStreaming
	}
	svcInfo := &kitex.ServiceInfo{
		ServiceName:     serviceName,
		HandlerType:     handlerType,
		Methods:         methods,
		PayloadCodec:    kitex.Protobuf,
		KiteXGenVersion: "v0.11.0",
		Extra:           extra,
	}
	return svcInfo
}

func createOrderReceiptHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(hqOrderReceipt.CreateOrderReceiptReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(hqOrderCenter.HqOrderService).CreateOrderReceipt(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *CreateOrderReceiptArgs:
		success, err := handler.(hqOrderCenter.HqOrderService).CreateOrderReceipt(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*CreateOrderReceiptResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newCreateOrderReceiptArgs() interface{} {
	return &CreateOrderReceiptArgs{}
}

func newCreateOrderReceiptResult() interface{} {
	return &CreateOrderReceiptResult{}
}

type CreateOrderReceiptArgs struct {
	Req *hqOrderReceipt.CreateOrderReceiptReq
}

func (p *CreateOrderReceiptArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(hqOrderReceipt.CreateOrderReceiptReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *CreateOrderReceiptArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *CreateOrderReceiptArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *CreateOrderReceiptArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *CreateOrderReceiptArgs) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.CreateOrderReceiptReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var CreateOrderReceiptArgs_Req_DEFAULT *hqOrderReceipt.CreateOrderReceiptReq

func (p *CreateOrderReceiptArgs) GetReq() *hqOrderReceipt.CreateOrderReceiptReq {
	if !p.IsSetReq() {
		return CreateOrderReceiptArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *CreateOrderReceiptArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *CreateOrderReceiptArgs) GetFirstArgument() interface{} {
	return p.Req
}

type CreateOrderReceiptResult struct {
	Success *hqOrderReceipt.CreateOrderReceiptResp
}

var CreateOrderReceiptResult_Success_DEFAULT *hqOrderReceipt.CreateOrderReceiptResp

func (p *CreateOrderReceiptResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(hqOrderReceipt.CreateOrderReceiptResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *CreateOrderReceiptResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *CreateOrderReceiptResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *CreateOrderReceiptResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *CreateOrderReceiptResult) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.CreateOrderReceiptResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *CreateOrderReceiptResult) GetSuccess() *hqOrderReceipt.CreateOrderReceiptResp {
	if !p.IsSetSuccess() {
		return CreateOrderReceiptResult_Success_DEFAULT
	}
	return p.Success
}

func (p *CreateOrderReceiptResult) SetSuccess(x interface{}) {
	p.Success = x.(*hqOrderReceipt.CreateOrderReceiptResp)
}

func (p *CreateOrderReceiptResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *CreateOrderReceiptResult) GetResult() interface{} {
	return p.Success
}

func getOrderReceiptListHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(hqOrderReceipt.GetOrderReceiptListReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(hqOrderCenter.HqOrderService).GetOrderReceiptList(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *GetOrderReceiptListArgs:
		success, err := handler.(hqOrderCenter.HqOrderService).GetOrderReceiptList(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*GetOrderReceiptListResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newGetOrderReceiptListArgs() interface{} {
	return &GetOrderReceiptListArgs{}
}

func newGetOrderReceiptListResult() interface{} {
	return &GetOrderReceiptListResult{}
}

type GetOrderReceiptListArgs struct {
	Req *hqOrderReceipt.GetOrderReceiptListReq
}

func (p *GetOrderReceiptListArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(hqOrderReceipt.GetOrderReceiptListReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *GetOrderReceiptListArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *GetOrderReceiptListArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *GetOrderReceiptListArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *GetOrderReceiptListArgs) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.GetOrderReceiptListReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var GetOrderReceiptListArgs_Req_DEFAULT *hqOrderReceipt.GetOrderReceiptListReq

func (p *GetOrderReceiptListArgs) GetReq() *hqOrderReceipt.GetOrderReceiptListReq {
	if !p.IsSetReq() {
		return GetOrderReceiptListArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *GetOrderReceiptListArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *GetOrderReceiptListArgs) GetFirstArgument() interface{} {
	return p.Req
}

type GetOrderReceiptListResult struct {
	Success *hqOrderReceipt.GetOrderReceiptListResp
}

var GetOrderReceiptListResult_Success_DEFAULT *hqOrderReceipt.GetOrderReceiptListResp

func (p *GetOrderReceiptListResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(hqOrderReceipt.GetOrderReceiptListResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *GetOrderReceiptListResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *GetOrderReceiptListResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *GetOrderReceiptListResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *GetOrderReceiptListResult) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.GetOrderReceiptListResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *GetOrderReceiptListResult) GetSuccess() *hqOrderReceipt.GetOrderReceiptListResp {
	if !p.IsSetSuccess() {
		return GetOrderReceiptListResult_Success_DEFAULT
	}
	return p.Success
}

func (p *GetOrderReceiptListResult) SetSuccess(x interface{}) {
	p.Success = x.(*hqOrderReceipt.GetOrderReceiptListResp)
}

func (p *GetOrderReceiptListResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *GetOrderReceiptListResult) GetResult() interface{} {
	return p.Success
}

func delOrderReceiptHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(hqOrderReceipt.DelOrderReceiptReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(hqOrderCenter.HqOrderService).DelOrderReceipt(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *DelOrderReceiptArgs:
		success, err := handler.(hqOrderCenter.HqOrderService).DelOrderReceipt(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*DelOrderReceiptResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newDelOrderReceiptArgs() interface{} {
	return &DelOrderReceiptArgs{}
}

func newDelOrderReceiptResult() interface{} {
	return &DelOrderReceiptResult{}
}

type DelOrderReceiptArgs struct {
	Req *hqOrderReceipt.DelOrderReceiptReq
}

func (p *DelOrderReceiptArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(hqOrderReceipt.DelOrderReceiptReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *DelOrderReceiptArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *DelOrderReceiptArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *DelOrderReceiptArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *DelOrderReceiptArgs) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.DelOrderReceiptReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var DelOrderReceiptArgs_Req_DEFAULT *hqOrderReceipt.DelOrderReceiptReq

func (p *DelOrderReceiptArgs) GetReq() *hqOrderReceipt.DelOrderReceiptReq {
	if !p.IsSetReq() {
		return DelOrderReceiptArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *DelOrderReceiptArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *DelOrderReceiptArgs) GetFirstArgument() interface{} {
	return p.Req
}

type DelOrderReceiptResult struct {
	Success *hqOrderReceipt.DelOrderReceiptResp
}

var DelOrderReceiptResult_Success_DEFAULT *hqOrderReceipt.DelOrderReceiptResp

func (p *DelOrderReceiptResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(hqOrderReceipt.DelOrderReceiptResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *DelOrderReceiptResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *DelOrderReceiptResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *DelOrderReceiptResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *DelOrderReceiptResult) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.DelOrderReceiptResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *DelOrderReceiptResult) GetSuccess() *hqOrderReceipt.DelOrderReceiptResp {
	if !p.IsSetSuccess() {
		return DelOrderReceiptResult_Success_DEFAULT
	}
	return p.Success
}

func (p *DelOrderReceiptResult) SetSuccess(x interface{}) {
	p.Success = x.(*hqOrderReceipt.DelOrderReceiptResp)
}

func (p *DelOrderReceiptResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *DelOrderReceiptResult) GetResult() interface{} {
	return p.Success
}

func updateOrderReceiptHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(hqOrderReceipt.UpdateOrderReceiptReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(hqOrderCenter.HqOrderService).UpdateOrderReceipt(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *UpdateOrderReceiptArgs:
		success, err := handler.(hqOrderCenter.HqOrderService).UpdateOrderReceipt(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*UpdateOrderReceiptResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newUpdateOrderReceiptArgs() interface{} {
	return &UpdateOrderReceiptArgs{}
}

func newUpdateOrderReceiptResult() interface{} {
	return &UpdateOrderReceiptResult{}
}

type UpdateOrderReceiptArgs struct {
	Req *hqOrderReceipt.UpdateOrderReceiptReq
}

func (p *UpdateOrderReceiptArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(hqOrderReceipt.UpdateOrderReceiptReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *UpdateOrderReceiptArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *UpdateOrderReceiptArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *UpdateOrderReceiptArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *UpdateOrderReceiptArgs) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.UpdateOrderReceiptReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var UpdateOrderReceiptArgs_Req_DEFAULT *hqOrderReceipt.UpdateOrderReceiptReq

func (p *UpdateOrderReceiptArgs) GetReq() *hqOrderReceipt.UpdateOrderReceiptReq {
	if !p.IsSetReq() {
		return UpdateOrderReceiptArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *UpdateOrderReceiptArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *UpdateOrderReceiptArgs) GetFirstArgument() interface{} {
	return p.Req
}

type UpdateOrderReceiptResult struct {
	Success *hqOrderReceipt.UpdateOrderReceiptResp
}

var UpdateOrderReceiptResult_Success_DEFAULT *hqOrderReceipt.UpdateOrderReceiptResp

func (p *UpdateOrderReceiptResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(hqOrderReceipt.UpdateOrderReceiptResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *UpdateOrderReceiptResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *UpdateOrderReceiptResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *UpdateOrderReceiptResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *UpdateOrderReceiptResult) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.UpdateOrderReceiptResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *UpdateOrderReceiptResult) GetSuccess() *hqOrderReceipt.UpdateOrderReceiptResp {
	if !p.IsSetSuccess() {
		return UpdateOrderReceiptResult_Success_DEFAULT
	}
	return p.Success
}

func (p *UpdateOrderReceiptResult) SetSuccess(x interface{}) {
	p.Success = x.(*hqOrderReceipt.UpdateOrderReceiptResp)
}

func (p *UpdateOrderReceiptResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *UpdateOrderReceiptResult) GetResult() interface{} {
	return p.Success
}

func countOrderReceiptHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(hqOrderReceipt.CountOrderReceiptReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(hqOrderCenter.HqOrderService).CountOrderReceipt(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *CountOrderReceiptArgs:
		success, err := handler.(hqOrderCenter.HqOrderService).CountOrderReceipt(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*CountOrderReceiptResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newCountOrderReceiptArgs() interface{} {
	return &CountOrderReceiptArgs{}
}

func newCountOrderReceiptResult() interface{} {
	return &CountOrderReceiptResult{}
}

type CountOrderReceiptArgs struct {
	Req *hqOrderReceipt.CountOrderReceiptReq
}

func (p *CountOrderReceiptArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(hqOrderReceipt.CountOrderReceiptReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *CountOrderReceiptArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *CountOrderReceiptArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *CountOrderReceiptArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *CountOrderReceiptArgs) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.CountOrderReceiptReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var CountOrderReceiptArgs_Req_DEFAULT *hqOrderReceipt.CountOrderReceiptReq

func (p *CountOrderReceiptArgs) GetReq() *hqOrderReceipt.CountOrderReceiptReq {
	if !p.IsSetReq() {
		return CountOrderReceiptArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *CountOrderReceiptArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *CountOrderReceiptArgs) GetFirstArgument() interface{} {
	return p.Req
}

type CountOrderReceiptResult struct {
	Success *hqOrderReceipt.CountOrderReceiptResp
}

var CountOrderReceiptResult_Success_DEFAULT *hqOrderReceipt.CountOrderReceiptResp

func (p *CountOrderReceiptResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(hqOrderReceipt.CountOrderReceiptResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *CountOrderReceiptResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *CountOrderReceiptResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *CountOrderReceiptResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *CountOrderReceiptResult) Unmarshal(in []byte) error {
	msg := new(hqOrderReceipt.CountOrderReceiptResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *CountOrderReceiptResult) GetSuccess() *hqOrderReceipt.CountOrderReceiptResp {
	if !p.IsSetSuccess() {
		return CountOrderReceiptResult_Success_DEFAULT
	}
	return p.Success
}

func (p *CountOrderReceiptResult) SetSuccess(x interface{}) {
	p.Success = x.(*hqOrderReceipt.CountOrderReceiptResp)
}

func (p *CountOrderReceiptResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *CountOrderReceiptResult) GetResult() interface{} {
	return p.Success
}

type kClient struct {
	c client.Client
}

func newServiceClient(c client.Client) *kClient {
	return &kClient{
		c: c,
	}
}

func (p *kClient) CreateOrderReceipt(ctx context.Context, Req *hqOrderReceipt.CreateOrderReceiptReq) (r *hqOrderReceipt.CreateOrderReceiptResp, err error) {
	var _args CreateOrderReceiptArgs
	_args.Req = Req
	var _result CreateOrderReceiptResult
	if err = p.c.Call(ctx, "CreateOrderReceipt", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) GetOrderReceiptList(ctx context.Context, Req *hqOrderReceipt.GetOrderReceiptListReq) (r *hqOrderReceipt.GetOrderReceiptListResp, err error) {
	var _args GetOrderReceiptListArgs
	_args.Req = Req
	var _result GetOrderReceiptListResult
	if err = p.c.Call(ctx, "GetOrderReceiptList", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) DelOrderReceipt(ctx context.Context, Req *hqOrderReceipt.DelOrderReceiptReq) (r *hqOrderReceipt.DelOrderReceiptResp, err error) {
	var _args DelOrderReceiptArgs
	_args.Req = Req
	var _result DelOrderReceiptResult
	if err = p.c.Call(ctx, "DelOrderReceipt", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) UpdateOrderReceipt(ctx context.Context, Req *hqOrderReceipt.UpdateOrderReceiptReq) (r *hqOrderReceipt.UpdateOrderReceiptResp, err error) {
	var _args UpdateOrderReceiptArgs
	_args.Req = Req
	var _result UpdateOrderReceiptResult
	if err = p.c.Call(ctx, "UpdateOrderReceipt", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) CountOrderReceipt(ctx context.Context, Req *hqOrderReceipt.CountOrderReceiptReq) (r *hqOrderReceipt.CountOrderReceiptResp, err error) {
	var _args CountOrderReceiptArgs
	_args.Req = Req
	var _result CountOrderReceiptResult
	if err = p.c.Call(ctx, "CountOrderReceipt", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}
