// Code generated by Kitex v0.11.0. DO NOT EDIT.

package temporalprintservice

import (
	"context"
	"errors"
	printer "git.downtown8.com/rms/orchestrator/g-hq-orchestrator/kitex_gen/middleplatform/printer"
	client "github.com/cloudwego/kitex/client"
	kitex "github.com/cloudwego/kitex/pkg/serviceinfo"
	streaming "github.com/cloudwego/kitex/pkg/streaming"
	proto "google.golang.org/protobuf/proto"
)

var errInvalidMessageType = errors.New("invalid message type for service method handler")

var serviceMethods = map[string]kitex.MethodInfo{
	"SavePrinter": kitex.NewMethodInfo(
		savePrinterHandler,
		newSavePrinterArgs,
		newSavePrinterResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"CopyPrinter": kitex.NewMethodInfo(
		copyPrinterHandler,
		newCopyPrinterArgs,
		newCopyPrinterResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"DelPrinter": kitex.NewMethodInfo(
		delPrinterHandler,
		newDelPrinterArgs,
		newDelPrinterResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"QueryPrinter": kitex.NewMethodInfo(
		queryPrinterHandler,
		newQueryPrinterArgs,
		newQueryPrinterResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"CreatePrintTask": kitex.NewMethodInfo(
		createPrintTaskHandler,
		newCreatePrintTaskArgs,
		newCreatePrintTaskResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"QueryTemplate": kitex.NewMethodInfo(
		queryTemplateHandler,
		newQueryTemplateArgs,
		newQueryTemplateResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"QueryStyle": kitex.NewMethodInfo(
		queryStyleHandler,
		newQueryStyleArgs,
		newQueryStyleResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"SaveStyle": kitex.NewMethodInfo(
		saveStyleHandler,
		newSaveStyleArgs,
		newSaveStyleResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
	"UpdateTaskStatus": kitex.NewMethodInfo(
		updateTaskStatusHandler,
		newUpdateTaskStatusArgs,
		newUpdateTaskStatusResult,
		false,
		kitex.WithStreamingMode(kitex.StreamingUnary),
	),
}

var (
	temporalPrintServiceServiceInfo                = NewServiceInfo()
	temporalPrintServiceServiceInfoForClient       = NewServiceInfoForClient()
	temporalPrintServiceServiceInfoForStreamClient = NewServiceInfoForStreamClient()
)

// for server
func serviceInfo() *kitex.ServiceInfo {
	return temporalPrintServiceServiceInfo
}

// for stream client
func serviceInfoForStreamClient() *kitex.ServiceInfo {
	return temporalPrintServiceServiceInfoForStreamClient
}

// for client
func serviceInfoForClient() *kitex.ServiceInfo {
	return temporalPrintServiceServiceInfoForClient
}

// NewServiceInfo creates a new ServiceInfo containing all methods
func NewServiceInfo() *kitex.ServiceInfo {
	return newServiceInfo(false, true, true)
}

// NewServiceInfo creates a new ServiceInfo containing non-streaming methods
func NewServiceInfoForClient() *kitex.ServiceInfo {
	return newServiceInfo(false, false, true)
}
func NewServiceInfoForStreamClient() *kitex.ServiceInfo {
	return newServiceInfo(true, true, false)
}

func newServiceInfo(hasStreaming bool, keepStreamingMethods bool, keepNonStreamingMethods bool) *kitex.ServiceInfo {
	serviceName := "TemporalPrintService"
	handlerType := (*printer.TemporalPrintService)(nil)
	methods := map[string]kitex.MethodInfo{}
	for name, m := range serviceMethods {
		if m.IsStreaming() && !keepStreamingMethods {
			continue
		}
		if !m.IsStreaming() && !keepNonStreamingMethods {
			continue
		}
		methods[name] = m
	}
	extra := map[string]interface{}{
		"PackageName": "temporalprint",
	}
	if hasStreaming {
		extra["streaming"] = hasStreaming
	}
	svcInfo := &kitex.ServiceInfo{
		ServiceName:     serviceName,
		HandlerType:     handlerType,
		Methods:         methods,
		PayloadCodec:    kitex.Protobuf,
		KiteXGenVersion: "v0.11.0",
		Extra:           extra,
	}
	return svcInfo
}

func savePrinterHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(printer.SavePrinterReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(printer.TemporalPrintService).SavePrinter(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *SavePrinterArgs:
		success, err := handler.(printer.TemporalPrintService).SavePrinter(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*SavePrinterResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newSavePrinterArgs() interface{} {
	return &SavePrinterArgs{}
}

func newSavePrinterResult() interface{} {
	return &SavePrinterResult{}
}

type SavePrinterArgs struct {
	Req *printer.SavePrinterReq
}

func (p *SavePrinterArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(printer.SavePrinterReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *SavePrinterArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *SavePrinterArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *SavePrinterArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *SavePrinterArgs) Unmarshal(in []byte) error {
	msg := new(printer.SavePrinterReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var SavePrinterArgs_Req_DEFAULT *printer.SavePrinterReq

func (p *SavePrinterArgs) GetReq() *printer.SavePrinterReq {
	if !p.IsSetReq() {
		return SavePrinterArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *SavePrinterArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *SavePrinterArgs) GetFirstArgument() interface{} {
	return p.Req
}

type SavePrinterResult struct {
	Success *printer.SavePrinterResp
}

var SavePrinterResult_Success_DEFAULT *printer.SavePrinterResp

func (p *SavePrinterResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(printer.SavePrinterResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *SavePrinterResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *SavePrinterResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *SavePrinterResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *SavePrinterResult) Unmarshal(in []byte) error {
	msg := new(printer.SavePrinterResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *SavePrinterResult) GetSuccess() *printer.SavePrinterResp {
	if !p.IsSetSuccess() {
		return SavePrinterResult_Success_DEFAULT
	}
	return p.Success
}

func (p *SavePrinterResult) SetSuccess(x interface{}) {
	p.Success = x.(*printer.SavePrinterResp)
}

func (p *SavePrinterResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *SavePrinterResult) GetResult() interface{} {
	return p.Success
}

func copyPrinterHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(printer.CopyPrinterReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(printer.TemporalPrintService).CopyPrinter(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *CopyPrinterArgs:
		success, err := handler.(printer.TemporalPrintService).CopyPrinter(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*CopyPrinterResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newCopyPrinterArgs() interface{} {
	return &CopyPrinterArgs{}
}

func newCopyPrinterResult() interface{} {
	return &CopyPrinterResult{}
}

type CopyPrinterArgs struct {
	Req *printer.CopyPrinterReq
}

func (p *CopyPrinterArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(printer.CopyPrinterReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *CopyPrinterArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *CopyPrinterArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *CopyPrinterArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *CopyPrinterArgs) Unmarshal(in []byte) error {
	msg := new(printer.CopyPrinterReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var CopyPrinterArgs_Req_DEFAULT *printer.CopyPrinterReq

func (p *CopyPrinterArgs) GetReq() *printer.CopyPrinterReq {
	if !p.IsSetReq() {
		return CopyPrinterArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *CopyPrinterArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *CopyPrinterArgs) GetFirstArgument() interface{} {
	return p.Req
}

type CopyPrinterResult struct {
	Success *printer.CopyPrinterResp
}

var CopyPrinterResult_Success_DEFAULT *printer.CopyPrinterResp

func (p *CopyPrinterResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(printer.CopyPrinterResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *CopyPrinterResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *CopyPrinterResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *CopyPrinterResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *CopyPrinterResult) Unmarshal(in []byte) error {
	msg := new(printer.CopyPrinterResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *CopyPrinterResult) GetSuccess() *printer.CopyPrinterResp {
	if !p.IsSetSuccess() {
		return CopyPrinterResult_Success_DEFAULT
	}
	return p.Success
}

func (p *CopyPrinterResult) SetSuccess(x interface{}) {
	p.Success = x.(*printer.CopyPrinterResp)
}

func (p *CopyPrinterResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *CopyPrinterResult) GetResult() interface{} {
	return p.Success
}

func delPrinterHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(printer.DelPrinterReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(printer.TemporalPrintService).DelPrinter(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *DelPrinterArgs:
		success, err := handler.(printer.TemporalPrintService).DelPrinter(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*DelPrinterResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newDelPrinterArgs() interface{} {
	return &DelPrinterArgs{}
}

func newDelPrinterResult() interface{} {
	return &DelPrinterResult{}
}

type DelPrinterArgs struct {
	Req *printer.DelPrinterReq
}

func (p *DelPrinterArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(printer.DelPrinterReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *DelPrinterArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *DelPrinterArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *DelPrinterArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *DelPrinterArgs) Unmarshal(in []byte) error {
	msg := new(printer.DelPrinterReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var DelPrinterArgs_Req_DEFAULT *printer.DelPrinterReq

func (p *DelPrinterArgs) GetReq() *printer.DelPrinterReq {
	if !p.IsSetReq() {
		return DelPrinterArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *DelPrinterArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *DelPrinterArgs) GetFirstArgument() interface{} {
	return p.Req
}

type DelPrinterResult struct {
	Success *printer.BaseResp
}

var DelPrinterResult_Success_DEFAULT *printer.BaseResp

func (p *DelPrinterResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(printer.BaseResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *DelPrinterResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *DelPrinterResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *DelPrinterResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *DelPrinterResult) Unmarshal(in []byte) error {
	msg := new(printer.BaseResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *DelPrinterResult) GetSuccess() *printer.BaseResp {
	if !p.IsSetSuccess() {
		return DelPrinterResult_Success_DEFAULT
	}
	return p.Success
}

func (p *DelPrinterResult) SetSuccess(x interface{}) {
	p.Success = x.(*printer.BaseResp)
}

func (p *DelPrinterResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *DelPrinterResult) GetResult() interface{} {
	return p.Success
}

func queryPrinterHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(printer.QueryPrinterReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(printer.TemporalPrintService).QueryPrinter(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *QueryPrinterArgs:
		success, err := handler.(printer.TemporalPrintService).QueryPrinter(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*QueryPrinterResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newQueryPrinterArgs() interface{} {
	return &QueryPrinterArgs{}
}

func newQueryPrinterResult() interface{} {
	return &QueryPrinterResult{}
}

type QueryPrinterArgs struct {
	Req *printer.QueryPrinterReq
}

func (p *QueryPrinterArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(printer.QueryPrinterReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *QueryPrinterArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *QueryPrinterArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *QueryPrinterArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *QueryPrinterArgs) Unmarshal(in []byte) error {
	msg := new(printer.QueryPrinterReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var QueryPrinterArgs_Req_DEFAULT *printer.QueryPrinterReq

func (p *QueryPrinterArgs) GetReq() *printer.QueryPrinterReq {
	if !p.IsSetReq() {
		return QueryPrinterArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *QueryPrinterArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *QueryPrinterArgs) GetFirstArgument() interface{} {
	return p.Req
}

type QueryPrinterResult struct {
	Success *printer.QueryPrinterResp
}

var QueryPrinterResult_Success_DEFAULT *printer.QueryPrinterResp

func (p *QueryPrinterResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(printer.QueryPrinterResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *QueryPrinterResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *QueryPrinterResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *QueryPrinterResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *QueryPrinterResult) Unmarshal(in []byte) error {
	msg := new(printer.QueryPrinterResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *QueryPrinterResult) GetSuccess() *printer.QueryPrinterResp {
	if !p.IsSetSuccess() {
		return QueryPrinterResult_Success_DEFAULT
	}
	return p.Success
}

func (p *QueryPrinterResult) SetSuccess(x interface{}) {
	p.Success = x.(*printer.QueryPrinterResp)
}

func (p *QueryPrinterResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *QueryPrinterResult) GetResult() interface{} {
	return p.Success
}

func createPrintTaskHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(printer.CreatePrintTaskReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(printer.TemporalPrintService).CreatePrintTask(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *CreatePrintTaskArgs:
		success, err := handler.(printer.TemporalPrintService).CreatePrintTask(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*CreatePrintTaskResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newCreatePrintTaskArgs() interface{} {
	return &CreatePrintTaskArgs{}
}

func newCreatePrintTaskResult() interface{} {
	return &CreatePrintTaskResult{}
}

type CreatePrintTaskArgs struct {
	Req *printer.CreatePrintTaskReq
}

func (p *CreatePrintTaskArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(printer.CreatePrintTaskReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *CreatePrintTaskArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *CreatePrintTaskArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *CreatePrintTaskArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *CreatePrintTaskArgs) Unmarshal(in []byte) error {
	msg := new(printer.CreatePrintTaskReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var CreatePrintTaskArgs_Req_DEFAULT *printer.CreatePrintTaskReq

func (p *CreatePrintTaskArgs) GetReq() *printer.CreatePrintTaskReq {
	if !p.IsSetReq() {
		return CreatePrintTaskArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *CreatePrintTaskArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *CreatePrintTaskArgs) GetFirstArgument() interface{} {
	return p.Req
}

type CreatePrintTaskResult struct {
	Success *printer.BaseResp
}

var CreatePrintTaskResult_Success_DEFAULT *printer.BaseResp

func (p *CreatePrintTaskResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(printer.BaseResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *CreatePrintTaskResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *CreatePrintTaskResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *CreatePrintTaskResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *CreatePrintTaskResult) Unmarshal(in []byte) error {
	msg := new(printer.BaseResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *CreatePrintTaskResult) GetSuccess() *printer.BaseResp {
	if !p.IsSetSuccess() {
		return CreatePrintTaskResult_Success_DEFAULT
	}
	return p.Success
}

func (p *CreatePrintTaskResult) SetSuccess(x interface{}) {
	p.Success = x.(*printer.BaseResp)
}

func (p *CreatePrintTaskResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *CreatePrintTaskResult) GetResult() interface{} {
	return p.Success
}

func queryTemplateHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(printer.Empty)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(printer.TemporalPrintService).QueryTemplate(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *QueryTemplateArgs:
		success, err := handler.(printer.TemporalPrintService).QueryTemplate(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*QueryTemplateResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newQueryTemplateArgs() interface{} {
	return &QueryTemplateArgs{}
}

func newQueryTemplateResult() interface{} {
	return &QueryTemplateResult{}
}

type QueryTemplateArgs struct {
	Req *printer.Empty
}

func (p *QueryTemplateArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(printer.Empty)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *QueryTemplateArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *QueryTemplateArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *QueryTemplateArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *QueryTemplateArgs) Unmarshal(in []byte) error {
	msg := new(printer.Empty)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var QueryTemplateArgs_Req_DEFAULT *printer.Empty

func (p *QueryTemplateArgs) GetReq() *printer.Empty {
	if !p.IsSetReq() {
		return QueryTemplateArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *QueryTemplateArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *QueryTemplateArgs) GetFirstArgument() interface{} {
	return p.Req
}

type QueryTemplateResult struct {
	Success *printer.QueryTemplateResp
}

var QueryTemplateResult_Success_DEFAULT *printer.QueryTemplateResp

func (p *QueryTemplateResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(printer.QueryTemplateResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *QueryTemplateResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *QueryTemplateResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *QueryTemplateResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *QueryTemplateResult) Unmarshal(in []byte) error {
	msg := new(printer.QueryTemplateResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *QueryTemplateResult) GetSuccess() *printer.QueryTemplateResp {
	if !p.IsSetSuccess() {
		return QueryTemplateResult_Success_DEFAULT
	}
	return p.Success
}

func (p *QueryTemplateResult) SetSuccess(x interface{}) {
	p.Success = x.(*printer.QueryTemplateResp)
}

func (p *QueryTemplateResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *QueryTemplateResult) GetResult() interface{} {
	return p.Success
}

func queryStyleHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(printer.QueryStyleReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(printer.TemporalPrintService).QueryStyle(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *QueryStyleArgs:
		success, err := handler.(printer.TemporalPrintService).QueryStyle(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*QueryStyleResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newQueryStyleArgs() interface{} {
	return &QueryStyleArgs{}
}

func newQueryStyleResult() interface{} {
	return &QueryStyleResult{}
}

type QueryStyleArgs struct {
	Req *printer.QueryStyleReq
}

func (p *QueryStyleArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(printer.QueryStyleReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *QueryStyleArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *QueryStyleArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *QueryStyleArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *QueryStyleArgs) Unmarshal(in []byte) error {
	msg := new(printer.QueryStyleReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var QueryStyleArgs_Req_DEFAULT *printer.QueryStyleReq

func (p *QueryStyleArgs) GetReq() *printer.QueryStyleReq {
	if !p.IsSetReq() {
		return QueryStyleArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *QueryStyleArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *QueryStyleArgs) GetFirstArgument() interface{} {
	return p.Req
}

type QueryStyleResult struct {
	Success *printer.QueryStyleResp
}

var QueryStyleResult_Success_DEFAULT *printer.QueryStyleResp

func (p *QueryStyleResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(printer.QueryStyleResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *QueryStyleResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *QueryStyleResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *QueryStyleResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *QueryStyleResult) Unmarshal(in []byte) error {
	msg := new(printer.QueryStyleResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *QueryStyleResult) GetSuccess() *printer.QueryStyleResp {
	if !p.IsSetSuccess() {
		return QueryStyleResult_Success_DEFAULT
	}
	return p.Success
}

func (p *QueryStyleResult) SetSuccess(x interface{}) {
	p.Success = x.(*printer.QueryStyleResp)
}

func (p *QueryStyleResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *QueryStyleResult) GetResult() interface{} {
	return p.Success
}

func saveStyleHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(printer.SaveStyleReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(printer.TemporalPrintService).SaveStyle(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *SaveStyleArgs:
		success, err := handler.(printer.TemporalPrintService).SaveStyle(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*SaveStyleResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newSaveStyleArgs() interface{} {
	return &SaveStyleArgs{}
}

func newSaveStyleResult() interface{} {
	return &SaveStyleResult{}
}

type SaveStyleArgs struct {
	Req *printer.SaveStyleReq
}

func (p *SaveStyleArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(printer.SaveStyleReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *SaveStyleArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *SaveStyleArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *SaveStyleArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *SaveStyleArgs) Unmarshal(in []byte) error {
	msg := new(printer.SaveStyleReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var SaveStyleArgs_Req_DEFAULT *printer.SaveStyleReq

func (p *SaveStyleArgs) GetReq() *printer.SaveStyleReq {
	if !p.IsSetReq() {
		return SaveStyleArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *SaveStyleArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *SaveStyleArgs) GetFirstArgument() interface{} {
	return p.Req
}

type SaveStyleResult struct {
	Success *printer.SaveStyleResp
}

var SaveStyleResult_Success_DEFAULT *printer.SaveStyleResp

func (p *SaveStyleResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(printer.SaveStyleResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *SaveStyleResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *SaveStyleResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *SaveStyleResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *SaveStyleResult) Unmarshal(in []byte) error {
	msg := new(printer.SaveStyleResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *SaveStyleResult) GetSuccess() *printer.SaveStyleResp {
	if !p.IsSetSuccess() {
		return SaveStyleResult_Success_DEFAULT
	}
	return p.Success
}

func (p *SaveStyleResult) SetSuccess(x interface{}) {
	p.Success = x.(*printer.SaveStyleResp)
}

func (p *SaveStyleResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *SaveStyleResult) GetResult() interface{} {
	return p.Success
}

func updateTaskStatusHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	switch s := arg.(type) {
	case *streaming.Args:
		st := s.Stream
		req := new(printer.UpdateTaskStatusReq)
		if err := st.RecvMsg(req); err != nil {
			return err
		}
		resp, err := handler.(printer.TemporalPrintService).UpdateTaskStatus(ctx, req)
		if err != nil {
			return err
		}
		return st.SendMsg(resp)
	case *UpdateTaskStatusArgs:
		success, err := handler.(printer.TemporalPrintService).UpdateTaskStatus(ctx, s.Req)
		if err != nil {
			return err
		}
		realResult := result.(*UpdateTaskStatusResult)
		realResult.Success = success
		return nil
	default:
		return errInvalidMessageType
	}
}
func newUpdateTaskStatusArgs() interface{} {
	return &UpdateTaskStatusArgs{}
}

func newUpdateTaskStatusResult() interface{} {
	return &UpdateTaskStatusResult{}
}

type UpdateTaskStatusArgs struct {
	Req *printer.UpdateTaskStatusReq
}

func (p *UpdateTaskStatusArgs) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetReq() {
		p.Req = new(printer.UpdateTaskStatusReq)
	}
	return p.Req.FastRead(buf, _type, number)
}

func (p *UpdateTaskStatusArgs) FastWrite(buf []byte) (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.FastWrite(buf)
}

func (p *UpdateTaskStatusArgs) Size() (n int) {
	if !p.IsSetReq() {
		return 0
	}
	return p.Req.Size()
}

func (p *UpdateTaskStatusArgs) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetReq() {
		return out, nil
	}
	return proto.Marshal(p.Req)
}

func (p *UpdateTaskStatusArgs) Unmarshal(in []byte) error {
	msg := new(printer.UpdateTaskStatusReq)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Req = msg
	return nil
}

var UpdateTaskStatusArgs_Req_DEFAULT *printer.UpdateTaskStatusReq

func (p *UpdateTaskStatusArgs) GetReq() *printer.UpdateTaskStatusReq {
	if !p.IsSetReq() {
		return UpdateTaskStatusArgs_Req_DEFAULT
	}
	return p.Req
}

func (p *UpdateTaskStatusArgs) IsSetReq() bool {
	return p.Req != nil
}

func (p *UpdateTaskStatusArgs) GetFirstArgument() interface{} {
	return p.Req
}

type UpdateTaskStatusResult struct {
	Success *printer.UpdateTaskStatusResp
}

var UpdateTaskStatusResult_Success_DEFAULT *printer.UpdateTaskStatusResp

func (p *UpdateTaskStatusResult) FastRead(buf []byte, _type int8, number int32) (n int, err error) {
	if !p.IsSetSuccess() {
		p.Success = new(printer.UpdateTaskStatusResp)
	}
	return p.Success.FastRead(buf, _type, number)
}

func (p *UpdateTaskStatusResult) FastWrite(buf []byte) (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.FastWrite(buf)
}

func (p *UpdateTaskStatusResult) Size() (n int) {
	if !p.IsSetSuccess() {
		return 0
	}
	return p.Success.Size()
}

func (p *UpdateTaskStatusResult) Marshal(out []byte) ([]byte, error) {
	if !p.IsSetSuccess() {
		return out, nil
	}
	return proto.Marshal(p.Success)
}

func (p *UpdateTaskStatusResult) Unmarshal(in []byte) error {
	msg := new(printer.UpdateTaskStatusResp)
	if err := proto.Unmarshal(in, msg); err != nil {
		return err
	}
	p.Success = msg
	return nil
}

func (p *UpdateTaskStatusResult) GetSuccess() *printer.UpdateTaskStatusResp {
	if !p.IsSetSuccess() {
		return UpdateTaskStatusResult_Success_DEFAULT
	}
	return p.Success
}

func (p *UpdateTaskStatusResult) SetSuccess(x interface{}) {
	p.Success = x.(*printer.UpdateTaskStatusResp)
}

func (p *UpdateTaskStatusResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *UpdateTaskStatusResult) GetResult() interface{} {
	return p.Success
}

type kClient struct {
	c client.Client
}

func newServiceClient(c client.Client) *kClient {
	return &kClient{
		c: c,
	}
}

func (p *kClient) SavePrinter(ctx context.Context, Req *printer.SavePrinterReq) (r *printer.SavePrinterResp, err error) {
	var _args SavePrinterArgs
	_args.Req = Req
	var _result SavePrinterResult
	if err = p.c.Call(ctx, "SavePrinter", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) CopyPrinter(ctx context.Context, Req *printer.CopyPrinterReq) (r *printer.CopyPrinterResp, err error) {
	var _args CopyPrinterArgs
	_args.Req = Req
	var _result CopyPrinterResult
	if err = p.c.Call(ctx, "CopyPrinter", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) DelPrinter(ctx context.Context, Req *printer.DelPrinterReq) (r *printer.BaseResp, err error) {
	var _args DelPrinterArgs
	_args.Req = Req
	var _result DelPrinterResult
	if err = p.c.Call(ctx, "DelPrinter", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) QueryPrinter(ctx context.Context, Req *printer.QueryPrinterReq) (r *printer.QueryPrinterResp, err error) {
	var _args QueryPrinterArgs
	_args.Req = Req
	var _result QueryPrinterResult
	if err = p.c.Call(ctx, "QueryPrinter", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) CreatePrintTask(ctx context.Context, Req *printer.CreatePrintTaskReq) (r *printer.BaseResp, err error) {
	var _args CreatePrintTaskArgs
	_args.Req = Req
	var _result CreatePrintTaskResult
	if err = p.c.Call(ctx, "CreatePrintTask", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) QueryTemplate(ctx context.Context, Req *printer.Empty) (r *printer.QueryTemplateResp, err error) {
	var _args QueryTemplateArgs
	_args.Req = Req
	var _result QueryTemplateResult
	if err = p.c.Call(ctx, "QueryTemplate", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) QueryStyle(ctx context.Context, Req *printer.QueryStyleReq) (r *printer.QueryStyleResp, err error) {
	var _args QueryStyleArgs
	_args.Req = Req
	var _result QueryStyleResult
	if err = p.c.Call(ctx, "QueryStyle", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) SaveStyle(ctx context.Context, Req *printer.SaveStyleReq) (r *printer.SaveStyleResp, err error) {
	var _args SaveStyleArgs
	_args.Req = Req
	var _result SaveStyleResult
	if err = p.c.Call(ctx, "SaveStyle", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) UpdateTaskStatus(ctx context.Context, Req *printer.UpdateTaskStatusReq) (r *printer.UpdateTaskStatusResp, err error) {
	var _args UpdateTaskStatusArgs
	_args.Req = Req
	var _result UpdateTaskStatusResult
	if err = p.c.Call(ctx, "UpdateTaskStatus", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}
