//go:build wireinject
// +build wireinject

// The build tag makes sure the stub is not built in the final build.
package main

import (
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/config"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler"
	mnovu "git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/message/novu"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/message/rabbitmq"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/rpcclient"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/server/rpc"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/svc/amqp"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/svc/novu"
	"github.com/google/wire"
)

func initApp(config.Config) (*rpc.KitexServer, func(), error) {
	panic(wire.Build(rpc.ProviderSet, handler.ProviderSet, rpcclient.ProviderSet, novu.ProviderSet, mnovu.ProviderSet, rabbitmq.ProviderSet, amqp.ProviderSet))
}
