// Code generated by Wire. DO NOT EDIT.

//go:generate go run -mod=mod github.com/google/wire/cmd/wire
//go:build !wireinject
// +build !wireinject

package main

import (
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/config"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/brand_store"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/kitchen"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/order"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/product"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/handler/public"
	novu2 "git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/message/novu"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/message/rabbitmq"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/rpcclient"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/server/rpc"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/svc/amqp"
	"git.downtown8.com/rms/orchestrator/g-hq-orchestrator/internal/svc/novu"
)

// Injectors from wire.go:

func initApp(configConfig config.Config) (*rpc.KitexServer, func(), error) {
	client := rpcclient.New(configConfig)
	kitchenService := kitchen.NewKitchenService(client)
	rabbitMQ, err := amqp.NewRabbitMQ(configConfig)
	if err != nil {
		return nil, nil, err
	}
	rabbitmqClient := rabbitmq.New(rabbitMQ)
	brandService := brand_store.NewBrandService(client, rabbitmqClient)
	novuNovu := novu.New(configConfig)
	novuClient := novu2.New(novuNovu)
	publicService := public.NewPublicService(client, novuClient, configConfig)
	service := product.NewProductService(client)
	orderService := order.NewOrderService(client, rabbitmqClient)
	v := handler.Register(kitchenService, brandService, publicService, service, orderService)
	kitexServer, err := rpc.New(configConfig, v...)
	if err != nil {
		return nil, nil, err
	}
	return kitexServer, func() {
	}, nil
}
